/* eslint-disable react-hooks/exhaustive-deps */
/* eslint-disable react/jsx-key */
import { Card, Tabs, Upload, message, Modal } from "antd";
import { useMemo } from "react";
import PremButton from "../PremButton"; //权限判断fn
import Mtable from "./mtable";
import { ImportOutlined } from "@ant-design/icons";
function isString(obj) {
  return obj.constructor === String ? true : false;
}

export default (props) => {
  // 导入配置
  const token =
    localStorage.getItem("TAIANTOKEN") ?? "3ae582cbf2b141d94de2da1b59d2701f";

  const importProps = {
    ...props?.importconfig,
    action: "/pl" + props?.importconfig?.action,
    showUploadList: false,
    name: "excelfile",
    headers: {
      // 'Content-Type': 'multipart/form-data',
      token: token,
    },
    onChange(info) {
      if (info.file.status !== "uploading") {
        console.log(info.file, info.fileList);
      }
      if (info.file.status === "done") {
        if (info.file.response?.code == "0000") {
          if (info.file.response?.data?.dataList?.length !== 0) {
            Modal.warning({
              title: "导入失败",
              width: 1000,
              okText: "知道了",
              content: (
                <div>
                  <Mtable
                    dataSource={info?.file?.response?.data?.dataList}
                    columns={[
                      {
                        title: "行数",
                        dataIndex: "name",
                        key: "name",
                        search: false,
                      },
                      {
                        title: "错误信息",
                        dataIndex: "error",
                        key: "error",
                        search: false,
                      },
                    ]}
                  />
                </div>
              ),
            });
            return;
          }
          message.success(`文件导入成功！`);
          props?.importconfig.reload();
        } else {
          message.warning(`${info.file.response?.msg}`);
          if (info.file.response?.code == "7777") {
            Modal.warning({
              title: "导入失败",
              width: 1000,
              okText: "知道了",
              content: (
                <div>
                  <Mtable
                    dataSource={info?.file?.response?.data?.dataList}
                    columns={[
                      {
                        title: "行数",
                        dataIndex: "name",
                        key: "name",
                        search: false,
                      },
                      {
                        title: "错误信息",
                        dataIndex: "error",
                        key: "error",
                        search: false,
                      },
                    ]}
                  />
                </div>
              ),
            });
          }
        }
      } else if (info.file.status === "error") {
        message.error(`${info.file.name} file upload failed.`);
      }
    },
  };

  let { childposition } = props;
  childposition = childposition ?? "left";
  const actionbtn = {
    add: (
      <PremButton {...props?.addconfig}>
        {props?.addconfig?.name || "新增"}
      </PremButton>
    ),
    export: (
      <PremButton {...props?.exportconfig}>
        {props?.exportconfig?.name || "导出"}
      </PremButton>
    ),
    import: (
      <Upload {...importProps}>
        <PremButton
          btn={{
            icon: <ImportOutlined />,
          }}
        >
          导入
        </PremButton>
      </Upload>
    ),
    download: (
      <PremButton {...props?.downloadconfig}>
        {props?.downloadconfig?.name || "下载模板"}
      </PremButton>
    ),
    custom: (
      <PremButton {...props?.customconfig}>
        {props?.customconfig?.name || "自定义"}
      </PremButton>
    ),
  };
  //右上角 pageextra 类型 1.reactDom 2.string 以逗号隔开 为none时不显示
  const renderextra = () => {
    if (props.pageextra && !isString(props.pageextra)) {
      if (typeof props?.pageextra == "function") {
        return props.pageextra?.();
      } else {
        return props.pageextra;
      }
    } else if (props.pageextra === "none") {
      return <div style={{ height: 28, width: 64 }} />;
    } else if (props.pageextra) {
      let strarr = props.pageextra ? props.pageextra.split(",") : ["add"];
      return strarr.map((it, i) => {
        return (
          <div key={i} style={{ marginRight: i == strarr.length - 1 ? 0 : 6 }}>
            {actionbtn[it]}
          </div>
        );
      });
    }
  };
  const items = useMemo(() => {
    if (props.tabList) {
      return props.tabList.map((it) => {
        return {
          label: it.tab,
          key: it.key,
          children: (
            <>
              <div style={{ display: "flex", width: "100%" }}>
                {(props.childposition == "left" || !props.childposition) &&
                  props.children}
                <div
                  style={{
                    flex: 1,
                    overflow: "hidden",
                    paddingLeft: `${
                      props.childposition == "left" ? "15px" : "0"
                    }`,
                  }}
                >
                  {props.childposition == "top" && props.children}
                  <Mtable
                    {...props}
                    iscurrent={props?.activeTabKey == it.key}
                  />
                </div>
                {(props.childposition == "right" || !props.childposition) &&
                  props.children}
              </div>
              {props.childposition == "bottom" && props.children}
            </>
          ),
        };
      });
    }
  }, [props.tabList, props.extraparams]);
  return (
    <div className="diycard">
      {props.withCard === false ? (
        <>
          <div style={{ display: "flex", width: "100%" }}>
            {(props.childposition == "left" || !props.childposition) &&
              props.children}
            <div style={{ flex: 1, width: "100%" }}>
              {props.childposition == "top" && props.children}
              <Mtable {...props} />
            </div>
            {(props.childposition == "right" || !props.childposition) &&
              props.children}
          </div>
          {props.childposition == "bottom" && props.children}
        </>
      ) : !props.tabList ? (
        <Card
          bordered={props.bordered === false ? false : true}
          style={{ height: "100%" }}
          title={props.pagetitle}
          extra={<div className="center">{renderextra()}</div>}
          activeTabKey={props.activeTabKey}
          tabList={props.tabList}
          onTabChange={props.onTabChange}
        >
          <div style={{ display: "flex", width: "100%" }}>
            {(props.childposition == "left" || !props.childposition) &&
              props.children}
            <div
              style={{
                flex: 1,
                overflow: "hidden",
                paddingLeft: `${props.childposition == "left" ? "15px" : "0"}`,
              }}
            >
              {props.childposition == "top" && props.children}
              <Mtable {...props} />
            </div>
            {(props.childposition == "right" || !props.childposition) &&
              props.children}
          </div>
          {props.childposition == "bottom" && props.children}
        </Card>
      ) : (
        <div className="tabstable">
          <div
            style={{
              display: "flex",
              justifyContent: "space-between",
              padding: "16px 20px 0",
            }}
          >
            <div style={{ fontSize: 16, fontWeight: 600 }}>
              {props.pagetitle}
            </div>
            <div style={{ display: "flex", flexDirection: "row" }}>
              {renderextra()}
            </div>
          </div>
          <Tabs
            className="autoTableTabs"
            items={items}
            onChange={props.onTabChange}
            destroyInactiveTabPane
            activeKey={props.activeTabKey}
          />
        </div>
      )}
    </div>
  );
};
